//*****************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
// File Name:ExIO_Pca9536.c
//
//  PC5(SCL): TWI-SCL
//  PC4(SDA): TWI-SDA
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2024/10/02 New Taishi
//  2024/10/08 Modify  for mega328_iic_oled_rtc Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<compat/twi.h>
#include	<avr/pgmspace.h>

#include	"mega_twi_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"

#include	"ExtIO_Pca9536_h.h"


unsigned char	gExInport;				// Ext Input Port
unsigned char	gExOutport;				// Ext Output Port
//*****************************************
// EXT. I/O Error dswDh^nG[
//  Oh^nANZX̃G[
//  uc: Error Code
//  G[R[h\Ă߂Ȃ
//
//   R[h̏ڂ "ExtIO_Pca9536_h.h" Q
//*****************************************
void	ExIO_error(unsigned char uc)
{

// ܂oĂȂ
#if	0
	cli();

	PORTE = 0x01;						// ROW1 ON
	PORTF = 0x00;

	PORTA = 0xff;						// COL G1--G8 OFF
	PORTB = 0xff;						// COL G9--G12 OFF
	PORTD |= 0xf0;						// COL R9--R12 OFF
	PORTG |= 0x0f;						// COL R13--R16 OFF
	PORTC = 0xff;						// COL R1---R8 OFF

	// 16x16 green LED Blink by Error Data
	while(1){
		PORTA = ~uc;					// COL R1---R8 : Error Data
		delay_ms(250);					// 250mS Delay
		PORTA = 0xff;					// COL R1---R8 OFF
		delay_ms(250);					// 250mS Delay
	}
#endif
	while(1){
		;
	}
}

//***************************
// Ext. I/O PCA9536 Config. Write
//
//  G[L鎞́AG[\āA
//  ߂Ȃ
//***************************
void	ext_io_config_set(void)
{
	unsigned char	r;

	r=twi_start(PCA9536_ADDR,TW_WRITE);				// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_START_TW_WRITE | ExtIO_ERR_CONF1);
		ExIO_error(r);								// G[\
	}
	r=twi_write(ExtIO_Command_Byte_Config);			// TWI ݒpR}hoCg
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_WRITE | ExtIO_ERR_CONF2);
		ExIO_error(r);								// G[\
	}

	r=twi_write(ExtIO_Config_Data);					// rbg̓o͐ݒf[^
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_WRITE | ExtIO_ERR_CONF3);
		ExIO_error(r);								// G[\
	}

	twi_stop();

}

//***************************
// Ext. IO PCA9536 Initial
//  Oo̓|[g̏ݒ
// TWȈ͗\ߍς܂Ă鎖Ƃ
//
//  G[L鎞́AG[\āA
//  ߂Ȃ
//***************************
void	ext_io_init(void)
{
	gExInport = 0x00;			// Ext Input Port
	gExOutport = 0x00;			// Ext Output Port

	ext_io_config_set();		// Ext.I/O Config. Set

	ext_io_write();
}

//***************************
// Ext. IO PCA9536  Input Port Data Read
//  O̓|[g̓ǂݏo
//  ǂݏof[^͈ȉ̕ϐɓ
//	unsigned char	gExInport	D3:S1 Set Switch
//
//  G[L鎞́AG[\āA
//  ߂Ȃ
//***************************
void	ext_io_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(PCA9536_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_START_TW_WRITE | ExtIO_ERR_READ1);
		ExIO_error(r);								// G[\
	}
	r = twi_write(ExtIO_Command_Byte_Input);		// TWI  i|[g͗pR}hoCgj
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_WRITE | ExtIO_ERR_READ2);
		ExIO_error(r);								// G[\
	}
	twi_stop();


	r = twi_start(PCA9536_ADDR,TW_READ);			// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_START_TW_READ | ExtIO_ERR_READ3);
		ExIO_error(r);								// G[\
	}
	r = twi_read(&data,ACK);						// TWI ǂݏoi|[g̓f[^j
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_READ | ExtIO_ERR_READ4);
		ExIO_error(r);								// G[\
	}
	gExInport = data;								// |[g̓f[^(D3:S1 Set Switch)

	twi_stop();

}

//***************************
// Ext. IO PCA9536  Output Port Data Write
//  Oo̓|[g̏
//  ݃f[^͈ȉ̕ϐɗL
//	unsigned char	gExOutport;	(D0:DS3 White LED, D1;DS4 Red LED, D2:DS5 Blue LED)
//
//  G[L鎞́AG[\āA
//  ߂Ȃ
//***************************
void	ext_io_write(void)
{
	unsigned char	r;

	r=twi_start(PCA9536_ADDR,TW_WRITE);				// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_START_TW_WRITE | ExtIO_ERR_WRITE1);
		ExIO_error(r);								// G[\
	}
	r=twi_write(ExtIO_Command_Byte_Output);			// TWI  i|[go͗pR}hoCgj
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_WRITE | ExtIO_ERR_WRITE2);
		ExIO_error(r);								// G[\
	}

	r=twi_write(gExOutport);						// o̓|[gɏof[^(D0:DS3 White LED, D1;DS4 Red LED, D2:DS5 Blue LED)
	if(r != 0){										// G[̎
		r = (ExtIO_ERR_TWI_WRITE | ExtIO_ERR_WRITE3);
		ExIO_error(r);								// G[\
	}

	twi_stop();

}

