//*****************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
// File Name:ExtIO_Pca9536_h.h
//  wb_[t@C
//
//  for Ext. I/O PCA9536
//
//
//  2024/10/02 New Taishi
//  2024/10/08 Modify  for mega328_iic_oled_rtc Taishi
//*****************************************

// *** Ext. I/O Device Address
#define PCA9536_ADDR					0x82	// I2C PCA9536 foCXAhX

// *** Ext. I/O Command Byte
#define	ExtIO_Command_Byte_Input		0x00	// ̓f[^鎞̃R}hoCg̒l
#define	ExtIO_Command_Byte_Output		0x01	// o̓f[^õR}hoCg̒l
#define	ExtIO_Command_Byte_Invers		0x02	// o̓f[^𔽓]鎞̃R}hoCg̒l
#define	ExtIO_Command_Byte_Config		0x03	// ݒf[^irbg̓o͐ݒj𑗂鎞̃R}hoCg̒l

// *** TWI Error Code ***
// D0 -- D3
#define	ExtIO_ERR_TWI_START_TW_WRITE	1
#define	ExtIO_ERR_TWI_WRITE				2
#define	ExtIO_ERR_TWI_START_TW_READ		3
#define	ExtIO_ERR_TWI_READ				4

// D4--D7
#define	ExtIO_ERR_CONF1					0x10
#define	ExtIO_ERR_CONF2					0x20
#define	ExtIO_ERR_CONF3					0x30
#define	ExtIO_ERR_READ1					0x40
#define	ExtIO_ERR_READ2					0x50
#define	ExtIO_ERR_READ3					0x60
#define	ExtIO_ERR_READ4					0x70
#define	ExtIO_ERR_WRITE1				0x80
#define	ExtIO_ERR_WRITE2				0x90
#define	ExtIO_ERR_WRITE3				0xA0
// *********************

// *** Ext. I/O Config Data 
//#define	ExtIO_Config_Data				0x08	// rbg̓o͐ݒf[^(IO3:Input, IO2:Output, IO1:Output, IO0:Output)
#define	ExtIO_Config_Data				0x06	// rbg̓o͐ݒf[^(IO3:Output, IO2:Input, IO1:Input, IO0:Output)

// *** Ext. Input ***
extern	unsigned char	gExInport;				// Ext Input Port ̃f[^(D2:Hard S2 Set Switch,D1:Hard S5 Select Switch)
#define	ExtIO_S2_Bit	0x04					// Set Switch
#define	ExtIO_S1_Bit	0x02					// Select Switch

// *** Ext. Output ***
extern	unsigned char	gExOutport;				// Ext Output Port ɏof[^(D0:Hard LED1 Red LED, D3;Hard LED4 Blue LED)
#define	ExtIO_RED_Bit	0x01
#define	ExtIO_BLU_Bit	0x08

// *** Ext. I/O Function ***
extern	void	ext_io_init(void);		// Ext. IO PCA9536 Initial
extern	void	ext_io_read(void);		// Ext. IO PCA9536  Input Port Data Read
extern	void	ext_io_write(void);		// Ext. IO PCA9536  Output Port Data Write

