//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//  file name: disp_gps_data.c
//
//   forMf[^\
//
//  2024/10/22  New (TAB4) Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"ir_dsm_38khz_h.h"
#include	"oled_1306_h.h"
#include	"glcd_7565_h.h"
#include	"ir_nixie_trnsceiver_h.h"

#include	"disp_gps_data_h.h"

enum DISP_FUNC_ITEM {		// \֐
		F_6x8 = 0,			// UW\
		F_12x16,			// PQPU\
		F_18x24,			// PWQS\
		F_24x32,			// QSRQ\

		F_END
	};

struct DISP_CONST {
	unsigned char dc_fsize;		//\tHgTCY
	unsigned char dc_x;			//\ʒuw
	unsigned char dc_y;			//\ʒux
	         char *dc_pdt;		//

};

static
struct DISP_CONST	gDisp_block_title[]={
	{F_18x24,   7*6, 0*8, "GPS"},
	{F_12x16,   6*6, 4*8, "V1.00"},

	{  F_END,     0,   0,   ""},			// I
};

//*****************************************
// ԊOjLV[[h̃^CǧŒ\
//*****************************************
void	disp_gps_mode_title(void)
{
	unsigned char		bn;
	unsigned char		*pbf;
	unsigned char		pos_x;				// hbgPʂ̂wʒu
	unsigned char		pos_y;				// hbgPʂ̂xʒu
	unsigned char		u_func;				// gp֐

	for(bn = 0;  ;bn++){
		if(gDisp_block_title[bn].dc_fsize == F_END){	// tHgTCY eQdlc͕̎\ȂŏI
			break;
		}

		u_func = gDisp_block_title[bn].dc_fsize;	// gp֐̎
		pos_x = gDisp_block_title[bn].dc_x;			// pos_x
		pos_y = gDisp_block_title[bn].dc_y;			// pos_y
		pbf = (unsigned char *)(gDisp_block_title[bn].dc_pdt);			// \

		if(u_func == F_24x32){
			disp_oled_G_24x32(pos_x, pos_y, pbf);	// x, y, data(24x32)
			disp_lcd_G_18x24(pos_x, pos_y, pbf);
		}else if(u_func == F_18x24){
			disp_oled_G_18x24(pos_x, pos_y, pbf);	// x, y, (18x24)
			disp_lcd_G_18x24(pos_x, pos_y, pbf);
		}else if(u_func == F_12x16){
			disp_oled_G_12x16(pos_x, pos_y, pbf);	// x, y, data(12x16)
			disp_lcd_G_12x16(pos_x, pos_y, pbf);
		}else{
			disp_oled_G_6x8(pos_x, pos_y, pbf);			// x, y, data(6x8)
			disp_lcd_G_6x8( pos_x,  pos_y, pbf);
		}
	}
}


//*****************************************
// Mf[^̕\ QOWs\
//*****************************************
void	proc_disp_rxd_gps(unsigned char uc, unsigned char init)
{
// ԍŏ̃f[^̎
//    ݂wʒuԍiOjɂB
//    āA݂xʒu̍sĂA
//    \hb̕\|C^[̍si{WjɂBiUR𒴂Oɂj
//    ݂݂̏xʒuƂwʒȕɏA݂wʒui{UjɂB
// '$'Ȁ݂݂wʒuOłȂA
//    ݂݈̏ʒuxi{WjɂāA݂wʒuԍiOjɂB
//    AAxʒuԉ̍siURj𒴂Aԏ̍sɂB
//    āA݂xʒu̍sĂA
//    \hb̕\|C^[̍si{WjɂBiUR𒴂Oɂj
//    ݂݂̏xʒuƂwʒȕɏA݂wʒui{UjɂB
// '$'Ȁ݂݂wʒuOA
//    ݂݂̏xʒuƂwʒȕɏA݂wʒui{UjɂB
// ̑̃f[^̎́Ȁ݂݂xʒuƂwʒȕɏA݂wʒui{UjɂB
//    ݂wʒuiPQW|UPQQj𒴂A݂wʒuԍiOjɂāA
//    ݂xʒui{WjBxʒuԉ̍siURj𒴂Aԏ̍sɂB
//    āA̍sĂA\hb̕\|C^[̍si{WjɂāAUR𒴂OɂB
//
//    ŏ݂̏xʒúAnkdcł͂OAfkbcł͂SWɂ
//    ׂ̏ɂ́AnkdcAfkbc̏̒ɕ\hb̕\|C^[
//    ֐KvɂȂ
//    ̓͂rrcPROŨR}h "Set Display Offset" g
//    \点̂łnkdc͏oB
//    Afkbc͓R}h󂯕tȂB
//    悤ȓ "Display start line" ƂR}hB
//    ͕\C͏ɂāAnkdcƓlȕ\ɂȂ
//    Ȃ̂ŁÃR}hgƂɂB
//

// '$'@bqAke܂ł̃f[^
//

	static	unsigned char	sDisp_IC_ypos = 0;
	static	unsigned char	sDisp_OLED_wr_ypos = 0;
	static	unsigned char	sDisp_GLCD_wr_ypos = 48;
	static	unsigned char	sDisp_wr_posx = 0;			// ނwʒu(0--(128-6))
	static	unsigned char	sDisp_first = 1;			// ꂪŏ̃f[^̎

	if(init != 0){
		sDisp_IC_ypos = 0;
		sDisp_OLED_wr_ypos = 0;
		sDisp_GLCD_wr_ypos = 48;
		sDisp_wr_posx = 0;
		sDisp_first = 1;								// ꂪŏ̃f[^̎
	}else{
		if(sDisp_first == 1){
			sDisp_first = 0;
			disp_clear_8line_oled_G(sDisp_OLED_wr_ypos);	// 8 Line Clear Display
			disp_clear_8line_lcd_G(sDisp_GLCD_wr_ypos);
			sDisp_IC_ypos += 8;
			set_offse_oled_G(sDisp_IC_ypos);				// OLED scroll
			set_offse_lcd_G(sDisp_IC_ypos);					// GLCD scroll
			disp_one_char_oled_G_6x8(sDisp_wr_posx, sDisp_OLED_wr_ypos, uc);
			disp_one_char_lcd_G_6x8(sDisp_wr_posx, sDisp_GLCD_wr_ypos, uc);
			sDisp_wr_posx += 6;
		}else{
			 if(uc == '$'){
				if(sDisp_wr_posx != 0){
					sDisp_wr_posx = 0;
					sDisp_OLED_wr_ypos += 8;
					if (63 < sDisp_OLED_wr_ypos){
						sDisp_OLED_wr_ypos = 0;
					}
					sDisp_GLCD_wr_ypos += 8;
					if (63 < sDisp_GLCD_wr_ypos){
						sDisp_GLCD_wr_ypos = 0;
					}
					disp_clear_8line_oled_G(sDisp_OLED_wr_ypos);	// 8 Line Clear Display
					disp_clear_8line_lcd_G(sDisp_GLCD_wr_ypos);
					sDisp_IC_ypos += 8;
					if (63 < sDisp_IC_ypos){
						sDisp_IC_ypos = 0;
					}
					set_offse_oled_G(sDisp_IC_ypos);				// OLED scroll
					set_offse_lcd_G(sDisp_IC_ypos);					// GLCD scroll
				}
				disp_one_char_oled_G_6x8(sDisp_wr_posx, sDisp_OLED_wr_ypos, uc);
				disp_one_char_lcd_G_6x8(sDisp_wr_posx, sDisp_GLCD_wr_ypos, uc);
				sDisp_wr_posx += 6;
			}else{
				disp_one_char_oled_G_6x8(sDisp_wr_posx, sDisp_OLED_wr_ypos, uc);
				disp_one_char_lcd_G_6x8(sDisp_wr_posx, sDisp_GLCD_wr_ypos, uc);
				sDisp_wr_posx += 6;
				if ((128-6) < sDisp_wr_posx){
					sDisp_wr_posx = 0;
					sDisp_OLED_wr_ypos += 8;
					if (63 < sDisp_OLED_wr_ypos){
						sDisp_OLED_wr_ypos = 0;
					}
					sDisp_GLCD_wr_ypos += 8;
					if (63 < sDisp_GLCD_wr_ypos){
						sDisp_GLCD_wr_ypos = 0;
					}
					disp_clear_8line_oled_G(sDisp_OLED_wr_ypos);	// 8 Line Clear Display
					disp_clear_8line_lcd_G(sDisp_GLCD_wr_ypos);
					sDisp_IC_ypos += 8;
					if (63 < sDisp_IC_ypos){
						sDisp_IC_ypos = 0;
					}
					set_offse_oled_G(sDisp_IC_ypos);				// OLED scroll
					set_offse_lcd_G(sDisp_IC_ypos);					// GLCD scroll
				}
			}
		}
	}

}

