//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//
//  file name: ir_dsm_38khz.c
//
//    DSM(Digital Signal Modurator: Use Timer0)ŕϒVAMo͂
//@@
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//   
//
//  2021/09/02  New (TAB4) Taishi
//  2024/10/10 Modify  for mega328_iic_oled_rtc Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"timer_h.h"
#include	"port_bit_h.h"

#include	"ir_dsm_38khz_h.h"

unsigned short	v_zero_on;				// [nmԁ@irj
unsigned short	v_zero_off;				// [neeԁirj
unsigned short	v_one_on;				// P@nmԁ@irj
unsigned short	v_one_off;				// P@neeԁirj
unsigned short	v_leader_on;			// [_[nmԁ@irj
unsigned short	v_leader_off;			// [_[neeԁirj
unsigned short	v_trailer_on;			// g|[@nmԁ@irj
unsigned short	v_trailer_off;			// g[[@neeԁirj

#define	NEC_1T_COUNT		40
static	unsigned char	sOne_time_count=0;			// mdb̂PsɁ|P
static	unsigned char	sT1_cnt = NEC_1T_COUNT;		// Ps𑪂JE^[


//*******************************************************
// DSM(Digital Signal Modurator) ̐ݒ inm^neeL[COj
//  ^C}[O(TC0)OC0A  38kHz̏o͂ɂ
//  ̏o͂nm^nee DSM 
//  L:13.16uS H:13.16uF ̐Mo悤ɐݒ肷
//  ̐M o^oȂ łcrl@\Ƃ
//
//  ^C}[O͈̓ʑovlɍsĂāA
//  óinbO`jMooȂ̐sB
//  ̑ }Nňȉ̒ʂ`
//   #define	OFF_38kHz	(TCCR0A &= ~(1 << COM0A0))
//   #define	ON_38kHz	(TCCR0A |= (1 << COM0A0))
//  
//*******************************************************
void	init_dsm(void)
{
	PORTD &=  ~(1 << PD6);												// IR LED OFF
	DDRD |= (1<< DDD6);

	TCCR0A = 0x00;														// Timer0 Stop
	PRR &= ~( 1 << PRTIM0 );											// Timer0 ғ

	TCNT0 = 0;															// Timer0 Count Set to ZERO
	OCR0A = 53;															// 37.59kHz
	TCCR0A = ( (0 << COM0A1) | (0 << COM0A0) | (0 << COM0B1) | (0 << COM0B0) | (0 << WGM01) | (1 << WGM00) );	// nbO`ؒfAnbOaؒfAʑovl
	TCCR0B = ( (1 << WGM02) | (0 << CS02) | (0 << CS01) | (1 << CS00) );										// ʑovl vXP[P^P

	TIMSK0 |= (1 << TOIE0);												// ꊄ݋iRWgj for 1T
}
//*******************************************************
// 	^C}[ÕI[o[t[
//  RWg̊荞݂Ȃ̂
//    mdbtH[}bgł͂QP񊄂荞ނƂPs̎ԂɂȂ
//  Ps̃JE^[̒l̓Cł͗p
//*******************************************************
ISR (TIMER0_OVF_vect)
{
	sT1_cnt--;
	if(sT1_cnt == 0){
		if(sOne_time_count != 0){
			sOne_time_count--;
		}
		sT1_cnt = NEC_1T_COUNT;
	}
}

//*******************************************************
//  Ps̃JE^[(gOne_time_count)ݒ肷
//  uc: Setting Value(1--255)
//*******************************************************
void	write_1T_count(unsigned char uc)
{
		sT1_cnt = NEC_1T_COUNT;
		sOne_time_count = uc;
}
//*******************************************************
//  Ps̃JE^[(sOne_time_count)ǂݏo
//  return: 1T Counter
//*******************************************************
unsigned char	read_1T_count(void)
{
		return(sOne_time_count);
}


//*******************************************************
// Transmit NEC AEHA DENON Leader Data
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_aeha_denon_leader(void)
{
	if(v_leader_on != 0){
		ON_38kHz;				// 38kHz ON
		wait_us(v_leader_on);	// Wait;
	}

	if(v_leader_off != 0){
		OFF_38kHz;				// 38kHz OFF
		wait_us(v_leader_off);	// Wait;
	}
}

//*******************************************************
// Transmit NEC AEHA DENON Trailer Data
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_aeha_denon_trailer(void)
{
	if(v_trailer_on != 0){
		ON_38kHz;				// 38kHz ON
		wait_us(v_trailer_on);	// Wait;
	}

	if(v_trailer_off != 0){
		OFF_38kHz;				// 38kHz OFF
		wait_us(v_trailer_off);	// Wait;
	}
}

//*******************************************************
// Transmit NEC AEHA DENON Form 1Byte
//     arg c : Transmit Data(1byte)
//  arg nbit : n of Transmit (bits)
//   MDBIT:0 -- 38kHz ON
//   MDBIT:1 -- 38kHz OFF
//*******************************************************
void	tx_nec_aeha_denon_form_char(unsigned char c, unsigned char nbit)
{
	unsigned char	i;
	unsigned char	b=0x80;
	unsigned char	n;

	if (8 <= nbit){
		n = 8;
	}else{
		n = nbit;
	}


	for(i=0;i<n;i++,b >>= 1){		// Bit7 --> Bit0 Transmit
		ON_38kHz;					// 38kHz ON
		wait_us(v_zero_on);			// Wait
		OFF_38kHz;					// 38kHz OFF
		if((c & b)==0){				// Bit : 0
			wait_us(v_zero_off);	// Wait
		}else{						// Bit : 1
			wait_us(v_one_off);		// Wait
		}
	}

}

//*******************************************************
// Transmit NEC AEHA DENON format new
//   arg nb1F1'st n of transmit bit
//   arg nb2F2'nd n of transmit bit
//   arg nb3F3'rd n of transmit bit
//   arg 1sFstring pointer
//*******************************************************
void	tx_nec_aeha_denon_form_new_str(unsigned char nb1, unsigned char nb2, unsigned char nb3, char *s)
{
	unsigned char	i;
	unsigned char	n;
	unsigned char	nb;

	nb = nb1;
	n  = (nb1 + 7)/8;

	tx_nec_aeha_denon_leader();					// Transmit Leader Data
	for(i=0;i<n;i++){
		tx_nec_aeha_denon_form_char(*s,nb);		// Transmit 1Byte (nb Bit)
		s++;
		nb -= 8;
	}
	tx_nec_aeha_denon_trailer();				// Transmit Trailer Data


	if(nb2 != 0){
		nb = nb2;
		n  = (nb2 + 7)/8;

		tx_nec_aeha_denon_leader();				// Transmit Leader Data
		for(i=0;i<n;i++){
			tx_nec_aeha_denon_form_char(*s,nb);	// Transmit 1Byte (nb Bit)
			s++;
			nb -= 8;
		}
		tx_nec_aeha_denon_trailer();			// Transmit Trailer Data

	}

	if(nb3 != 0){
		nb = nb3;
		n  = (nb3 + 7)/8;

		tx_nec_aeha_denon_leader();				// Transmit Leader Data
		for(i=0;i<n;i++){
			tx_nec_aeha_denon_form_char(*s,nb);	// Transmit 1Byte (nb Bit)
			s++;
			nb -= 8;
		}
		tx_nec_aeha_denon_trailer();			// Transmit Trailer Data

	}
}

