//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//
//  file name: ir_nec_trnsceiver.c
//
// mdb[h̐ԊOM
//
// M
//  PCINT16(PD0,RXD)̃VAM̂nm^neeԂO^P𔻕ʂ
//  SoCg̃f[^PubNƂĔFĎM
//  PCINT16̊ݐMƃ^C}[P̃JEgMf[^
//  f[^̂nmԂ̓`FbNȂB
//
//
// M
//  RWgoׂ͂̃^C}[O̖PXg̊݉񐔂JEgA
//  𗘗pĂRWĝnmԁAneeԂ𐧌䂷
//
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//   
//
//  2024/10/28  New (TAB4) Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	"port_bit_h.h"

#include	"ir_dsm_38khz_h.h"
#include	"ir_nec_trnsceiver_h.h"


unsigned char	reader_h_on[3];			// [_[̂nmԏWrbg
unsigned char	reader_l_on[3];			// [_[̂nmԉWrbg
unsigned char	reader_h_off[3];		// [_[̂neeԏWrbg
unsigned char	reader_l_off[3];		// [_[̂neeԉWrbg

// ---- mdbtH[}bgp(1T:560) -----
#define	V_ZERO_ON_NEC		560				// [nmԁ@irj(1T)
#define	V_ZERO_OFF_NEC		560				// [neeԁirj(1T)
#define	V_ONE_ON_NEC		560				// P@nmԁ@irj(1T)
#define	V_ONE_OFF_NEC		1680			// P@neeԁirj(3T)
#define	V_LEADER_ON_NEC		8960			// [_[nmԁ@irj(16T)
#define	V_LEADER_OFF_NEC	4480			// [_[neeԁirj(8T)
#define	V_TRAILER_ON_NEC	560				// g|[@nmԁ@irj(1T)
#define	V_TRAILER_OFF_NEC	40000			// g[[@neeԁirj
#define	V_ZERO_MIN_NEC		890				// [艺irj(1T+1T) 1120x0.8
#define	V_ZERO_MAX_NEC		1340			// [irj(1T+1T) 1120x1.2
#define	V_ONE_MIN_NEC		1790			// P艺irj(1T+3T) 2240x0.8
#define	V_ONE_MAX_NEC		2680			// Pirj(1T+3T) 2240x1.2
#define	V_LEADER_MIN_NEC	10750			// [_[ƔF	ŏԒl(uS)(16T+8T) 13440x0.8
#define	V_LEADER_ON_MIN_NEC	7168			// [_[ƔF	ŏԒl(uS)(16T) 8960x0.8


enum NEC_REC_STAT {			// f[^鎞̏ԑJ
		WAIT_READER_ON = 0,	// [_[nm҂
		WAIT_READER_OFF,	// [_[nee҂
		WAIT_DATA_ON0,		// Prbgڂ̃f[^nm҂
		WAIT_DATA_ON17,		// QrbgڂWrbgڂ܂Ńf[^nm҂
		WAIT_DATA_OFF07,	// f[^nee҂
		WAIT_STOP_OFF,		// Xgbvrbgnee҂
		WAIT_DISP_COMP,		// f[^̕\I҂
		WAIT_NG_OFF,		// f[^mf̌̂nee҂

		WAIT_END
	};

	unsigned char			gErr_ir_nec = 0;
	unsigned short			gT1_count = 0;
	unsigned short			gT1_min = 0;
	unsigned short			gT1_max = 0;

	static	unsigned char	sRead_stat=0;			// enum NEC_STAT ̒lԂɓ
	static	unsigned char	sN_of_rec=0;			// M f[^̃oCg
	static	unsigned char	sN_of_bit=0;			// Mrbg
	static	unsigned char	sByte = 0;

	static	unsigned short	v_zero_min;				// OƔFŏԒl(uS)
	static	unsigned short	v_zero_max;				// OƔFő厞Ԓl(uS)
	static	unsigned short	v_one_min;				// PƔFŏԒl(uS)
	static	unsigned short	v_one_max;				// PƔFő厞Ԓl(uS)
	static	unsigned short	v_leader_min;			// [_[inm{neejƔFŏԒl(uS)
	static	unsigned short	v_leader_on_min;		// [_[̂nmƔFŏԒl(uS)

	static	unsigned char	sTm1_ovf;				// OFslP̃I[o[t[APFI[o[t[L

#define			NEC_NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			NEC_DATA_WARITE_POS_MASK	(NEC_NofRxdBuf - 1)
	static	unsigned short	nec_rxd_data[NEC_NofRxdBuf];						// Mf[^obt@
	static	unsigned char	nec_write_rxd_pos = 0;
	static	unsigned char	nec_read_rxd_pos = 0;


//*******************************************************
// ԊOmdbp̃f[^̎擾̊Jn
//*******************************************************
void	start_ir_nec_data(void)
{
	unsigned char	uc;

	sRead_stat=WAIT_READER_ON;				// enum NEC_STAT ̒lԂɓ
	sN_of_rec=0;							// M f[^̃oCg@SoCg΁AXgbvrbg҂
	for(uc = 0; uc<NEC_NofRxdBuf; uc++){
		nec_rxd_data[uc]=0;					// Mf[^߂鏊
	}
	nec_write_rxd_pos = 0;
	nec_read_rxd_pos = 0;
											// |||@mdbtH[}bg@|||
	v_zero_min = V_ZERO_MIN_NEC;			// OƔFŏԒl(uS)A[艺irj(1T+1T) 1120x0.8
	v_zero_max = V_ZERO_MAX_NEC;			// OƔFő厞Ԓl(uS)A[irj(1T+1T) 1120x1.2
	v_one_min = V_ONE_MIN_NEC;				// PƔFŏԒl(uS)AP艺irj(1T+3T) 2240x0.8
	v_one_max = V_ONE_MAX_NEC;				// PƔFő厞Ԓl(uS)APirj(1T+3T) 2240x1.2
	v_leader_min = V_LEADER_MIN_NEC;		// [_[inm{neejƔFŏԒl(uS)(16T+8T) 13440x0.8
	v_leader_on_min = V_LEADER_ON_MIN_NEC;	// [_[̂nmƔFŏԒl(uS)(16T+8T) 13440x0.8
}
//*******************************************************
//ԊOmdbp̃^C}[P̏
// Pr̃JE^[Ƃē삳iNbNFWlgj
// ʏ퓮ł͊荞݂͎g킸AJE^[l̓ǂݏɂȂ
// AAُ펖Ԃ̎̂߂ɁAOɂȂɊ荞܂KvLiI[o[t[݁j
//*******************************************************
void	timer1_nec_init(void)
{
	TCCR1B = 0x00;									// Timer1 Stop
	PRR &= ~( 1 << PRTIM1 );						// Timer1 ғ

	TCNT1 = 0;										// Timer1 Count Set to ZERO
	TCCR1A = ( (0 << COM1A1) | (0 << COM1A0) | (0 << COM1B1) | (0 << COM1B0) | (0 << WGM11) | (0 << WGM10) );	// W TOP= 0xffff,

	TIFR1 = 0;										// Interrupt Flag Clear
	TCCR1B = ( (0 << WGM13) | (0 << WGM12) | (0 << CS12) | (1 << CS11) | (0 << CS10) );	// W 1/8
	TIMSK1 |= (1 << TOIE1);							// Over Flow Interrupt Enable

}
//*******************************************************
//ԊOmdbp̃^C}[P̃JEgJn
//*******************************************************
void	timer1_nec_start(void)
{
	TIFR1 = 0;										// Interrupt Flag Clear
	TCCR1B = ( (0 << WGM13) | (0 << WGM12) | (0 << CS12) | (1 << CS11) | (0 << CS10) );	// W 1/8
	TIMSK1 |= (1 << TOIE1);							// Over Flow Interrupt Enable

}
//*******************************************************
//ԊOmdbp̃^C}[P̃JEg~
//*******************************************************
void	timer1_nec_stop(void)
{
	TCCR1B = 0x00;							// Timer1 Stop
	TIMSK1 &= ~(1 << TOIE1);				// Over Flow Interrupt Disable
	TIFR1 = 0;								// Interrupt Flag Clear
}

//*******************************************************
//ԊOmdbpOCINT16̏
//*******************************************************
void	pcint16_init(void)
{
	DDRD &= ~(1 << DDD0);						// PCINT16(PD0):input
	PCICR  |= (1 << PCIE2);						// PCIINT16<-->23 Enable
	PCMSK2 = (1 << PCINT16);					// PCONT16 Interrupt Enable
}

//*******************************************************
// 	^C}[P̃I[o[t[
//  PrłOȂ̂
//  UTTRTriUTrjo߂Ɗ荞
//  [_[ĂAM̂nm^neeԊuŁA
//  ܂Œ͖̂ŁA[_[ĂA
//  Xgbvrbg܂ł̊ԂɁAɊ荞񂾂
//  I[o[t[tO𗧂Ă
//  Cł͂̃tOďB
//*******************************************************
ISR (TIMER1_OVF_vect)
{
	sTm1_ovf = 1;
}
//***************************
// NEC RXD Write to Ring Buffer
//***************************
void	nec_wrt_buf(unsigned short us)
{
	unsigned char	wr_pos;

	wr_pos = nec_write_rxd_pos;
	nec_rxd_data[wr_pos] = us;							// Mf[^obt@ɏ
	wr_pos++;
	wr_pos &= NEC_DATA_WARITE_POS_MASK;
	if(wr_pos != nec_read_rxd_pos){						// ݈ʒuǂݏoʒuɒǂĂȂiޗ]nLj
		nec_write_rxd_pos = wr_pos;
	}

}
//***************************
// NEC RXD Read from Ring Buffer 
//  Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	nec_get_rxd(unsigned short *us)
{
	unsigned char	r=0;

	if(nec_write_rxd_pos == nec_read_rxd_pos){						// Mf[^
		;
	}else{
		r = 1;
		*us = nec_rxd_data[nec_read_rxd_pos];						// Mf[^obt@擾
		nec_read_rxd_pos++;
		nec_read_rxd_pos &= NEC_DATA_WARITE_POS_MASK;
	}
	return(r);
}


//*******************************************************
// M[h NEC
// obhmsPŮ荞݂gď
// 荞ݏłPoCg̃f[^Oobt@ɓA
// Cł̓Oobt@ǂݏoďB
// obhmsPŮ荞݂łɗB
// 
// nm̎iocOkjƂnee̎iocOgj̏傫Qɕ
//
// 
// 
// Enm͍̎̃JE^[lƃI[o[t[tOۑ
//   JE^[OɂăI[o[t[tONAB
//   ́ȀԂɂAςB
//
// Enee͕̎ۑI[o[t[tOPA
//   Ń[_[̂nmƔfB
//   łȂ́AJE^[lă[_[ƔFl傫
//   ̑O[_[̂nmƔf
//   łȂȂOf[^̂nmƔfāA
//   ̏ɂB{Iɏ͖͂
// 
//   ̑O[_[̂nmƔf̏ƂĂ
//   ̏ŏ̃f[^̂Prbgڂ̏ɂB
//   ̑Of[^̂nmƔf
//   ̏w肳Ă͂Ȃ̂ŁAɏ͂ȂB
// 
// 
// 
// 
//*******************************************************
ISR (PCINT2_vect)
{
	static	unsigned char	red=1;
	unsigned char	bit_valid;
	unsigned char	save_ovf;
	unsigned short	save_cnt;
	unsigned short	us;

	led_red_on_off(red);
	red ^= 1;

	save_cnt = TCNT1;						// JE^[ǂ
	save_ovf = sTm1_ovf;					// I[o[t[tOǂ
	if((PIND & 0x01) != 0){					// ԊOM@neeɂȂ
		if(sTm1_ovf != 0){					// I[o[t[Ă
			sRead_stat = WAIT_DATA_ON0;
			sN_of_rec=0;					// M f[^̃oCgO
			sN_of_bit=0;
		}else if(v_leader_on_min <= save_cnt){	// [_[nmƔFŏԒl
			sRead_stat = WAIT_DATA_ON0;
			sN_of_rec=0;					// M f[^̃oCgO
			sN_of_bit=0;
		}
	}else{									// ԊOM@nmɂȂ
		TCNT1 = 0;							// JE^[Oɂ
		sTm1_ovf = 0;						// I[o[t[tONA[

		switch(sRead_stat){
		 case WAIT_DATA_ON0:						// Prbgڂ̃f[^̐ML҂
			if((v_leader_min <= save_cnt)&&(save_ovf == 0)){			// ̑O[_[Ɣ nj
				sRead_stat = WAIT_DATA_ON17;
			}else{								// mf
				gErr_ir_nec = sRead_stat;
				gT1_count = save_cnt;
				gT1_min = v_leader_min;
				sRead_stat = WAIT_READER_ON;	// ēx[_҂
			}
			break;
		 case WAIT_DATA_ON17:						// QrbgڂWrbgڂ܂ł̃f[^̐ML҂
			if((v_zero_min <= save_cnt) && (save_cnt <= v_zero_max) && (save_ovf == 0)){	// PrbgڂOƔ nj
				bit_valid = 1;
			}else if((v_one_min <= save_cnt) && (save_cnt <= v_one_max) && (save_ovf == 0)){	// PrbgڂPƔ nj
				sByte |= 1;
				bit_valid = 1;
			}
			if(bit_valid == 1){					// JEg͈͓̎iȂO͂Pjj
				if(sN_of_bit < 7){				// WrbgĂȂ
					sByte <<= 1;
					sN_of_bit++;
				}else{							// Wrbg
					us = sN_of_rec;				// < make save data
					us++;
					us <<= 8;
					us |= sByte;
					nec_wrt_buf(us);			// save data to ring buffer
					sN_of_rec++;				// < n of save data +1

					sN_of_bit = 0;
					sByte = 0;
				}
			}else{								// mf
				gErr_ir_nec = sRead_stat;
				gT1_count = save_cnt;
				gT1_min = v_zero_min;
				gT1_max = v_one_max;
				sRead_stat = WAIT_READER_ON;
			}
			break;
		 default:								// ȂiG[͗邩Ȃj
			sRead_stat = WAIT_READER_ON;
			break;
		}
	}
}



//*******************************************************
// Transmit Data (NEC format)
//*******************************************************
unsigned char	str_nec_form[2][10]={											
//            NofData 1'st 2'nd 3'rd 4'th 5'th 6'th 7'th 8'th
			{ 0x04,   0x41,0xb6,0xd5,0x2a,0x00,0x00,0x00,0x00},		// S1: NEC Ceiling Light ON/OFF
			{ 0x05,   0x01,0x17,0x48,0x00,0x4c,0x00,0x00,0x00},		// S2: I/O-TV Power
		};

//enum NEC_TRS_STAT {			// f[^𑗂鎞̏ԑJ
//		TRS_NON = 0,		// MĂȂ
//		TRS_READER_ON,		// [_[nmM
//		TRS_READER_OFF,		// [_[neeM
//		TRS_DATA_ON,		// f[^nmM
//		TRS_DATA_OFF,		// f[^neeM
//		TRS_STOP_ON,		// XgbvrbgnmM
//		TRS_STOP_OFF,		// XgbvrbgneeM
//
//		TRS_END
//	};

#define	NEC_READER_ON_T		16		// 16T
#define	NEC_READER_OFF_T	8		//  8T
#define	NEC_DATA_ON_T		1		//  1T
#define	NEC_DATA_OFF_ONE_T	3		//  3T
#define	NEC_DATA_OFF_ZERO_T	1		//  1T
#define	NEC_STOP_ON_T		1		//  1T
#define	NEC_STOP_OFF_T		14		// 14T

//*****************************************
// mdbtH[}bg̑M
//   @uc: transmit data Number 1:NEC Ceiling Light ON/OFF, 2:I/O-TV Power
//            PƂQȊO͉ȂŏI
//
//  Mf[^ unsigned char	str_nec_form[2][10] ɗL
//*****************************************
void	transmit_nec_data(unsigned char uc)
{
static	unsigned char	sNofData=0;
static	unsigned char	sTrs_data[10]={0,0,0,0,0,0,0,0,0,0};
	unsigned char	count_1t;
	unsigned char	i;
	unsigned char	j;
	unsigned char	bit;
	unsigned char	byte_data;

	if((uc == 1)||(uc == 2)){					// PƂQɌ肷
		led_blu_on_off(1);						// Blue LED ON
		uc--;
		sNofData = str_nec_form[uc][0];
		for(i=0;i<9;i++){
			sTrs_data[i] = str_nec_form[uc][i+1];
		}
		write_1T_count(NEC_READER_ON_T);
		ON_38kHz;

		// [_[̂nm (TRS_READER_ON)
		while(1){
			count_1t = read_1T_count();
			if(count_1t == 0){
				OFF_38kHz;
				write_1T_count(NEC_READER_OFF_T);
				break;
			}
		}

		// [_[̂nee (TRS_READER_OFF)
		while(1){
			count_1t = read_1T_count();
			if(count_1t == 0){
				ON_38kHz;
				write_1T_count(NEC_DATA_ON_T);
				break;
			}
		}

		// f[^̏o
		for(i=0;i<sNofData;i++){								// f[^ o
			byte_data = sTrs_data[i];
			// f[^̂nm (TRS_DATA_ON)
			for(j=0,bit=0x80;j<8;j++,bit >>= 1){				// Wrbg o
				while(1){
					count_1t = read_1T_count();
					if(count_1t == 0){
						OFF_38kHz;
						if((byte_data & bit) == 0){
							write_1T_count(NEC_DATA_OFF_ZERO_T);
						}else{
							write_1T_count(NEC_DATA_OFF_ONE_T);
						}
						break;
					}
				}

				// f[^̂nee (TRS_DATA_OFF)
				while(1){
					count_1t = read_1T_count();
					if(count_1t == 0){
						ON_38kHz;
						write_1T_count(NEC_DATA_ON_T);
						break;
					}
				}
			}
		}

//		write_1T_count(NEC_STOP_ON_T);
		// Xgbvrbĝnm (TRS_STOP_ON)
		while(1){
			count_1t = read_1T_count();
			if(count_1t == 0){
				OFF_38kHz;
				write_1T_count(NEC_STOP_OFF_T);
				break;
			}
		}

		// Xgbvrbĝnee (TRS_STOP_OFF)
		while(1){
			count_1t = read_1T_count();
			if(count_1t == 0){
				break;
			}
		}
		led_blu_on_off(0);						// Blue LED OFF
	}
}

