//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//  file name: ir_nixie_trnsceiver.c
//
//   VAԊOʐMvOɏCB
//
//  2017/10/21  New (TAB4) Taishi
//  2024/10/11  Modify  for mega328_iic_oled_rtc Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"mega328_iic_oled_rtc_h.h"
#include	"timer_h.h"
#include	"ir_dsm_38khz_h.h"
#include	"ir_nixie_trnsceiver_h.h"

// aor
#define	BIT_RATE600			600								// rbg|g:600
#define	BIT_RATE1200		1200							// rbg|g:1200
#define	BIT_RATE2400		2400							// rbg|g:2400
#define	BIT_RATE4800		4800							// rbg|g:4800
#define	BIT_RATE9600		9600							// rbg|g:9600

// t`qs̐ݒl

// aor
#define	BPS_600			(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE600) - 1)	// taqqO̒l(600)
#define	BPS_1200		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE1200) - 1)	// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE2400) - 1)	// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE4800) - 1)	// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE9600) - 1)	// taqqO̒l(9600)


// #define			NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			NofRxdBuf				512					// Mf[^obt@̑傫iQ̊KɌj
															// for̎Af[^݂Ȃ̂ő傫B
#define			DATA_WARITE_POS_MASK	(NofRxdBuf - 1)
unsigned char	rxd_data[NofRxdBuf];						// Mf[^obt@
// unsigned char	write_rxd_pos = 0;
// unsigned char	read_rxd_pos = 0;
unsigned short	write_rxd_pos = 0;
unsigned short	read_rxd_pos = 0;
															// for̎Af[^݂Ȃ̂ő傫B

unsigned short	gVAL_BPS = BPS_600;

// t`qs̐ݒl

// peB
#define	V_PARITY_NON	((0 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY_EVN	((1 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY_ODD	((1 << UPM01) | (1 << UPM00))									// peB

// f[^
#define	V_DATA_8		((1 << UCSZ00) | (1 << UCSZ01))									// Wrbgf[^
#define	V_DATA_7		((0 << UCSZ00) | (1 << UCSZ01))									// Vrbgf[^

// tbrqO`̒l
#define	V_UCSR0A		(0 << U2X0)														// tbrqO`̒l: WiWlg͔̎{̕덷Ȃj

// tbrqOa̒l
//#define	V_UCSR0B		(1 << TXEN0)												// tbrqOa̒l: M
//#define	V_UCSR0B		((1 << RXEN0) | (1 << RXCIE0) | (1 << TXEN0))				// tbrqOa̒l: MAM荞݉AM
#define	V_UCSR0B		((1 << RXEN0) | (1 << RXCIE0))									// tbrqOa̒l: MAM荞݉
//#define	V_UCSR0B_TX		((1 << RXEN0) | (1 << TXEN0))								// tbrqOa̒l: MAM
//#define	V_UCSR0B		(1 << RXEN0)												// tbrqOa̒l: M


//*****************************************
// M@UOOaor
//*****************************************
void	tx_600_char(char c)
{
	unsigned char	i;
	unsigned char	b=0x01;

	ON_38kHz;					// X^[grbg38kHz ON
	wait_us(1666);				//	1.666ҋ@;

	for(i=0;i<8;i++,b <<= 1){	// f[^rbg
		if((c & b)==0){
			ON_38kHz;			// Bit = Low 38kHz ON
		}else{
			OFF_38kHz;			// Bit = High 38kHz OFF
		}
		wait_us(1666);		//	1.666ҋ@;
	}

	OFF_38kHz;					// Xgbvrbg 38kHz OFF
	wait_us(1666);			//	1.666ҋ@;

}

//*****************************************
//  M@UOOaor
//   @Fi|C^[j^[~l[^͂OOO
//*****************************************
void	tx_600_str(char *s)
{
	while(*s != 0x00){
		tx_600_char(*s);		// M@UOOaor
		s++;
	}
}

//***************************
// UART Initial RX Only 600BPS
//***************************
void	uart_init_rx_600(void)
{

	// UOO`XUOO̊Ԃ̓{[Cgݒ背WX^̏ʂWrbg͏ɂO
	gVAL_BPS = BPS_600;

	delay_2us(100/2);									// POOr҂

	UBRR0H  = (unsigned char)(gVAL_BPS >> 8);			// aor High
	UBRR0L  = (unsigned char)gVAL_BPS;					// aor Low

	UCSR0C = (V_PARITY_NON | V_DATA_8);					// peBAf[^

	UCSR0A = V_UCSR0A;
	UCSR0B = V_UCSR0B;									// RX only
}

//***************************
// UART Initial RX Only 9600BPS
//***************************
void	uart_init_rx_9600(void)
{

	// UOO`XUOO̊Ԃ̓{[Cgݒ背WX^̏ʂWrbg͏ɂO
	gVAL_BPS = BPS_9600;

	delay_2us(100/2);									// POOr҂

	UBRR0H  = (unsigned char)(gVAL_BPS >> 8);			// aor High
	UBRR0L  = (unsigned char)gVAL_BPS;					// aor Low

	UCSR0C = (V_PARITY_NON | V_DATA_8);					// peBAf[^

	UCSR0A = V_UCSR0A;
	UCSR0B = V_UCSR0B;									// RX only
}

//***************************
// UART Close
//***************************
void	uart_close(void)
{
	UCSR0B = 0x00;
	delay_2us(100/2);											// POOr҂
}

//***************************
// UART RxD One Char
//  荞݂gȂ
//  ߂lFOf[^APf[^L
//***************************
unsigned char	uart_rx_one(unsigned char *uc)
{
	unsigned char	r=0;
	unsigned char	er;
	unsigned char	c;

	
	if((UCSR0A & (1<<RXC0))!= 0){							// Mf[^
		er = (UCSR0A & ((1<<FE0)|(1<<DOR0)|(1<<UPE0)) );	// G[Ԏ擾
		c = UDR0;
		if(er == 0){										// G[
			*uc = c;
			r = 1;
		}
	}

	return(r);
}

//***************************
// UART0 RXD Interrupt
//***************************
ISR	(USART_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
//	unsigned char	wr_pos;
	unsigned short	wr_pos;								// for̎Af[^݂Ȃ̂ő傫B

	er = (UCSR0A & ((1<<FE0)|(1<<DOR0)|(1<<UPE0)) );	// G[Ԏ擾
	uc = UDR0;											// Mf[^擾

	if(er == 0){										// G[
		wr_pos = write_rxd_pos;
		rxd_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd_pos){						// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd_pos = wr_pos;
		}
	}

}
//***************************
// RXD Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd_uart(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd_pos == read_rxd_pos){						// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd_data[read_rxd_pos];						// Mf[^obt@擾
		read_rxd_pos++;
		read_rxd_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}

