//*****************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
// File Name:port_bit.c
//
//  2012/06/13 ishi New
//  2023/03/07 Modify for mega328_i2c_old Taishi
//  2023/05/13 Modify for mega328_iic_oled_rtc Taishi
//*****************************************

#include	<avr/io.h>

#include	"timer_h.h"
#include	"ExtIO_Pca9536_h.h"
#include	"disp_clock_data_h.h"

#include	"port_bit_h.h"

unsigned char	sw1_continue_count = 0;
unsigned char	sw2_continue_count = 0;

//******************************
// Ext I/O RED LED ON/OFF
//  on_off : 1=ON, 0=OFF
//  \߁@Og|[g̐ݒ肪Kv
// *****************************
void	led_ext_red_on_off(unsigned char on_off)
{
	if(on_off == 0){
		gExOutport &= ~ExtIO_RED_Bit;		// LED OFF
	}else{
		gExOutport |=  ExtIO_RED_Bit;		// LED ON
	}
	ext_io_write();							// Ext. IO PCA9536  Output Port Data Write
}

//******************************
// Ext I/O BLUE LED ON/OFF
//  on_off : 1=ON, 0=OFF
//  \߁@Og|[g̐ݒ肪Kv
// *****************************
void	led_ext_blu_on_off(unsigned char on_off)
{
	if(on_off == 0){
		gExOutport &= ~ExtIO_BLU_Bit;		// LED OFF
	}else{
		gExOutport |=  ExtIO_BLU_Bit;		// LED ON
	}
	ext_io_write();							// Ext. IO PCA9536  Output Port Data Write
}

//******************************
// GREEN LED ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	led_grn_on_off(unsigned char on_off)
{
	if(on_off == 0){
		PORTC &= ~(1 << PC0);		// LED OFF
	}else{
		PORTC |=  (1 << PC0);		// LED ON
	}
}

//******************************
// RED LED ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	led_red_on_off(unsigned char on_off)
{
	if(on_off == 0){
		PORTC &= ~(1 << PC1);		// LED OFF
	}else{
		PORTC |=  (1 << PC1);		// LED ON
	}
}

//******************************
// BLUE LED ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	led_blu_on_off(unsigned char on_off)
{
	if(on_off == 0){
		PORTC &= ~(1 << PC2);		// LED OFF
	}else{
		PORTC |=  (1 << PC2);		// LED ON
	}
}

//******************************
// BLUE LED Invert
// *****************************
void	led_blu_invert(void)
{
	PORTC ^=  (1 << PC2);		// LED Invert

}

//******************************
// LED ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	led_on_off(unsigned char on_off)
{
	if(on_off == 0){
		PORTD &= ~(1 << PD1);		// LED OFF
	}else{
		PORTD |=  (1 << PD1);		// LED ON
	}
}

unsigned char	sw[4];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//  \߁@Og|[g̐ݒ肪Kv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		ext_io_read();										// Ext. IO PCA9536  Input Port Data Read
		uc = ((~gExInport) & (SW1_ON_BIT | SW2_ON_BIT));	// ]ăXCb`f[^擾
		gDebdata = uc;
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}

//***************************
//@XCb`֌W̏ݒ
//***************************
void	sw_init(void)
{
	sw1_continue_count = 0;
	sw2_continue_count = 0;

}


#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWR_ON_CONTINUEvo^C~OɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
unsigned short	get_action_sw(void)
{
	unsigned short	us=0;

	get_sw();												// XCb`Ԃ

	// SW-1(SET)
	if((sw[2] & SW1_ON_BIT) != 0){							// XCb`Pnm̏uԂ̎(set switch)
		us |= (SW1_ON_NOW | SW1_ON);
		tim_10ms_sw1_continue = TMR_CONTIMUE;
		tim_10ms_sw1_length = TMR_LONG;
		sw1_continue_count = 1;
	}else if((sw[1] & SW1_ON_BIT) != 0){					// XCb`Pnm̎(set switch)
		us |= SW1_ON;
		if(tim_10ms_sw1_continue == 0){						// ꑱo^C~O̎
			us |= SW1_ON_CONTINUE;
			if(sw1_continue_count < 2){
				sw1_continue_count++;
				tim_10ms_sw1_continue = TMR_CONTIMUE;
			}else{
				tim_10ms_sw1_continue = TMR_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW1_ON_BIT) != 0){					// XCb`PꂽuԂ̎(set switch)
		if(tim_10ms_sw1_length == 0){						// ꂽԂ
			us |= SW1_OFF_LONG;
		}else{												// ꂽԂZ
			us |= SW1_OFF_SHORT;
		}
		tim_10ms_sw1_continue = 0;
		tim_10ms_sw1_length = 0;
		sw1_continue_count = 0;
	}else if((sw[1] & SW1_ON_BIT) == 0){					// XCb`Pnee̎(set switch)
		tim_10ms_sw1_continue = 0;
		tim_10ms_sw1_length = 0;
		sw1_continue_count = 0;
	}

	// SW-2(SELECT)
	if((sw[2] & SW2_ON_BIT) != 0){							// XCb`Qnm̏uԂ̎(select switch)
		us |= (SW2_ON_NOW | SW2_ON);
		tim_10ms_sw2_continue = TMR_CONTIMUE;
		tim_10ms_sw2_length = TMR_LONG;
		sw2_continue_count = 1;
	}else if((sw[1] & SW2_ON_BIT) != 0){					// XCb`Qnm̎(select switch)
		us |= SW2_ON;
		if(tim_10ms_sw2_continue == 0){						// ꑱo^C~O̎
			us |= SW2_ON_CONTINUE;
			if(sw2_continue_count < 2){
				sw2_continue_count++;
				tim_10ms_sw2_continue = TMR_CONTIMUE;
			}else{
				tim_10ms_sw2_continue = TMR_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW2_ON_BIT) != 0){					// XCb`QꂽuԂ̎(select switch)
		if(tim_10ms_sw2_length == 0){						// ꂽԂ
			us |= SW2_OFF_LONG;
		}else{												// ꂽԂZ
			us |= SW2_OFF_SHORT;
		}
		tim_10ms_sw2_continue = 0;
		tim_10ms_sw2_length = 0;
		sw2_continue_count = 0;
	}else if((sw[1] & SW2_ON_BIT) == 0){					// XCb`Qnee̎(select switch)
		tim_10ms_sw2_continue = 0;
		tim_10ms_sw2_length = 0;
		sw2_continue_count = 0;
	}

	return(us);
}

//*****************************************
// Q̃XCb`Q@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer2 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){											// ̂rv܂ő҂
		get_action_sw();								// XCb`Ԃ
		if( (sw[1] & (SW1_ON | SW2_ON)) == 0 ){		// ꂽ
			break;
		}
	}
}
//*****************************************
// Q̃XCb`Q@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//  \߁@Og|[g̐ݒ肪Kv
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		ext_io_read();											// Ext. IO PCA9536  Input Port Data Read
		if(((~gExInport) & (SW1_ON_BIT | SW2_ON_BIT)) == 0){	// XCb`f[^ OFF
			delay_ms(100);										// 100mS Delay
			ext_io_read();										// Ext. IO PCA9536  Input Port Data Read
			if(((~gExInport) & (SW1_ON_BIT | SW2_ON_BIT)) == 0){	// XCb`f[^ OFF
				break;											// {ɗꂽƂ
			}
		}
	}
}
