//*****************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//
//@OLED 128x64 Control IC: SSD1306
//    H@nkdc\ihhbj
//
//@GLCD 128x48 Control IC: SSD1306 like
//    H@f@kbc\iroh{j
//
//@RTC RX8900(EPSON)
//      ihhbj
//
// File Name:pr_clock_mode.c
//
//  PC5(SCL): TWI-SCL
//  PC4(SDA): TWI-SDA
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2023/03/07 New  for mega328_i2c_oled Taishi
//  2023/05/13 Modify  for mega328_iic_oled_rtc Taishi
//
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"timer_h.h"
#include	"mega_Twi_h.h"
#include	"port_bit_h.h"
#include	"oled_1306_h.h"
#include	"disp_clock_data_h.h"
#include	"Rtc_Rx8900_h.h"
#include	"set_rtc_h.h"
#include	"ExtIO_Pca9536_h.h"
#include	"glcd_7565_h.h"
#include	"ir_dsm_38khz_h.h"
#include	"pr_ir_nixie_mode_h.h"

#include	"pr_clock_mode_h.h"

//*****************************************
// v[h̃C
//*****************************************
void clock_mode_main(void)
{
	unsigned char	uc;
	unsigned short	us;

	led_red_on_off(1);
	led_grn_on_off(1);
	led_blu_on_off(1);

	disp_clear_oled_G();							// Clear All Display
	disp_clear_lcd_G();
	disp_clock_mode_title();						// ^CǧŒ\
	delay_ms(1000);
	for(uc=0;uc < 64;uc++){							// XN[
		set_offse_oled_G(uc);						// OLED scroll
		set_offse_lcd_G(uc);						// GLCD scroll
		delay_ms(100);
	}
	delay_ms(1000);

	led_red_on_off(0);
	led_grn_on_off(0);
	led_blu_on_off(0);
	disp_clear_oled_G();							// Clear All Display
	disp_clear_lcd_G();

	led_blu_on_off(1);
	uc = rtc_init();								//  qsb̏ݒ
	if(uc != 0){
		rtc_error();								// qsbG[
	}
	delay_ms(100);
	led_blu_on_off(0);

	led_grn_on_off(1);
	uc = rtc_read();								// RTC N ǂݏo
	if(uc != 0){
		rtc_error();								// qsbG[
	}

	uc = rtc_tempe_read();							// RTC xf[^ǂݏo
	if(uc != 0){
		rtc_error();								// qsbG[
	}
	delay_ms(100);
	led_grn_on_off(0);

	disp_clear_oled_G();							// Clear All Display
	disp_clear_lcd_G();
	disp_clock_const();								// v̌Œ\
	disp_clock_data(1);								// vf[^̕\i1=Sĕ\j
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((us & SW1_OFF_LONG) != 0){			// ꎞ(set switch)
				proc_set_rtc();						// v킹
				disp_clock_data(1);					// vf[^̕\i1=Sĕ\j
			}
		}

		if(rtc_1s_flg != 0){						// Pbo߂
			rtc_1s_flg = 0;
			led_grn_on_off(1);
			uc = rtc_read();						// RTC N ǂݏo
			if(uc != 0){
				rtc_error();						// qsbG[
			}
			uc = rtc_tempe_read();					// RTC xf[^ǂݏo
			if(uc != 0){
				rtc_error();						// qsbG[
			}
			disp_clock_data(0);						// vf[^̕\i0=ω̕\j
			led_grn_on_off(0);
		}

	}
}
