//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//  file name: pr_gps_mode.c
//
//   forMvO
//
//  2014/10/22  New (TAB4) Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"ir_dsm_38khz_h.h"
#include	"oled_1306_h.h"
#include	"glcd_7565_h.h"
#include	"ir_nixie_trnsceiver_h.h"
#include	"disp_gps_data_h.h"

#include	"pr_gps_mode_h.h"


//*****************************************
// for[h̃C
//*****************************************
void gps_mode_main(void)
{
	static unsigned char	uc;
	unsigned char	disp_on = 1;
	unsigned short	us;

	led_red_on_off(1);
	led_grn_on_off(1);
	led_blu_on_off(1);

	disp_clear_oled_G();							// Clear All Display
	disp_clear_lcd_G();
	disp_gps_mode_title();						// ^CǧŒ\
	delay_ms(1000);
	for(uc=0;uc < 64;uc++){							// XN[
		set_offse_oled_G(uc);						// OLED scroll
		set_offse_lcd_G(uc);						// GLCD scroll
		delay_ms(100);
	}
	delay_ms(1000);


	led_red_on_off(0);
	led_grn_on_off(0);
	led_blu_on_off(0);

	led_blu_on_off(1);
	timer1_init();
	delay_ms(100);
	led_blu_on_off(0);

	led_grn_on_off(1);
	init_dsm();
	delay_ms(100);
	led_grn_on_off(0);

	cli();
	uart_init_rx_9600();						// UART Initial RX 9600BPS

	sei();										// 荞݉

	proc_disp_rxd_gps(uc,1);					// display RXD initial
	while(1){
		us = get_action_sw();					// XCb`Ԃ
		us &= SW_MASK;							// XCb`ɂ
		if((us & SW2_OFF_SHORT) != 0){			// Zė(select switch)
			disp_on ^= 1;
		}else if((us & SW2_OFF_LONG) != 0){			// ė(select switch)
			disp_on ^= 1;
		}

		if(Get_rxd_uart(&uc) != 0){
			if(disp_on != 0){
				led_red_on_off(1);
				proc_disp_rxd_gps(uc,0);			// display RXD
				led_red_on_off(0);
			}
		}
	}
}

