//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//  file name: pr_ir_nec_mode.c
//
//
//  2024/10/22  New (TAB4) Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"ir_dsm_38khz_h.h"
#include	"oled_1306_h.h"
#include	"glcd_7565_h.h"
#include	"ir_nixie_trnsceiver_h.h"
#include	"ir_nec_trnsceiver_h.h"
#include	"disp_ir_nec_data_h.h"

#include	"pr_ir_nec_mode_h.h"


//*****************************************
// XCb`ꂽ̐ԊOM
//   @FXCb`
//*****************************************
void	proc_nec_switch_on(unsigned short us)
{
	if((us & SW2_ON_NOW) != 0){				// ꂽ(select switch)
		transmit_nec_data(2);				// I/O TV: ON/OFF

		return;
	}else if((us & SW1_ON_NOW) != 0){		// ꂽ(set switch)
		transmit_nec_data(1);				// NEC Light: ON/OFF

		return;
	}
}

//*****************************************
// mdb[h̃C
//*****************************************
void ir_nec_mode_main(void)
{
	static unsigned char	uc;
	unsigned short	us;

	led_red_on_off(1);
	led_grn_on_off(1);
	led_blu_on_off(1);

	disp_clear_oled_G();							// Clear All Display
	disp_clear_lcd_G();
	disp_ir_nec_mode_title();						// ^CǧŒ\
	delay_ms(1000);
	for(uc=0;uc < 64;uc++){							// XN[
		set_offse_oled_G(uc);						// OLED scroll
		set_offse_lcd_G(uc);						// GLCD scroll
		delay_ms(100);
	}
	delay_ms(1000);


	led_red_on_off(0);
	led_grn_on_off(0);
	led_blu_on_off(0);

	led_blu_on_off(1);
	timer1_init();
	delay_ms(100);
	led_blu_on_off(0);

	led_grn_on_off(1);
	init_dsm();
	delay_ms(100);
	led_grn_on_off(0);

	cli();
	pcint16_init();								//ԊOmdbpOCINT16̏
	timer1_nec_init();							//ԊOmdbp̃^C}[P̏
	sei();										// 荞݉

	proc_ndisp_rxd_nec(us,1);
	while(1){
		us = get_action_sw();					// XCb`Ԃ
		us &= SW_MASK;							// XCb`ɂ
		if(us != 0){							// ANVL鎞
			led_grn_on_off(1);
			proc_nec_switch_on(us);				// XCb`ꂽ̐ԊOM
			led_grn_on_off(0);
		}

		uc = nec_get_rxd(&us);
		if (uc != 0){
			proc_ndisp_rxd_nec(us,0);				// Mf[^̕\
		}

		if(	gErr_ir_nec != 0){
			proc_disp_err_range_over(gErr_ir_nec, gT1_count, gT1_min, gT1_max);
			gErr_ir_nec = 0;
		}

	}
}

