//*******************************************************
// Graphic OLED & RTC(RX8900) Test Program ATMega328
// CPU Clock:External 8MHz
//   iq[Yf[^@WȂŁAOUWlgɂj
//
//  file name: pr_ir_nixie.c
//
//   VAԊOʐMvOɏCB
//
//  2017/10/21  New (TAB4) Taishi
//  2024/10/11  Modify  for mega328_iic_oled_rtc Taishi
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"ir_dsm_38khz_h.h"
#include	"oled_1306_h.h"
#include	"glcd_7565_h.h"
#include	"ir_nixie_trnsceiver_h.h"
#include	"disp_ir_nixie_data_h.h"

#include	"pr_ir_nixie_mode_h.h"


char	str_sxxe[2][4][5]={			// s11e  s88e ܂ł̃f[^
		{
			{'s','1','1','e',0x00},		// s11e Mf[^ set n߂
			{'s','2','2','e',0x00},		// s22e Mf[^ set A
			{'s','3','3','e',0x00},		// s33e Mf[^ set Z
			{'s','4','4','e',0x00},		// s44e Mf[^ set 
		},
		{
			{'s','5','5','e',0x00},		// s55e Mf[^ select n߂
			{'s','6','6','e',0x00},		// s66e Mf[^ select A
			{'s','7','7','e',0x00},		// s77e Mf[^ select Z
			{'s','8','8','e',0x00},		// s88e Mf[^ select 
		},
};


//*****************************************
// rdsXCb`u
//*****************************************
void	tx_600_str_set_on_now(void)
{
	tx_600_str(&str_sxxe[0][0][0]);	// set n߂ M
}

//*****************************************
// rdsXCb`Ă
//*****************************************
void	tx_600_str_set_continue(void)
{
	tx_600_str(&str_sxxe[0][1][0]);	// set  M
}

//*****************************************
// rdsXCb`Zė
//*****************************************
void	tx_600_str_set_short(void)
{
	tx_600_str(&str_sxxe[0][2][0]);	// set Zė M
}

//*****************************************
// rdsXCb`ė
//*****************************************
void	tx_600_str_set_long(void)
{
	tx_600_str(&str_sxxe[0][3][0]);	// set ė M
}


//*****************************************
// rdkdbsXCb`u
//*****************************************
void	tx_600_str_select_on_now(void)
{
	tx_600_str(&str_sxxe[1][0][0]);	// set n߂ M
}

//*****************************************
// rdkdbsXCb`Ă
//*****************************************
void	tx_600_str_select_continue(void)
{
	tx_600_str(&str_sxxe[1][1][0]);	// set  M
}

//*****************************************
// rdkdbsXCb`Zė
//*****************************************
void	tx_600_str_select_short(void)
{
	tx_600_str(&str_sxxe[1][2][0]);	// set Zė M
}

//*****************************************
// rdkdbsXCb`ė
//*****************************************
void	tx_600_str_select_long(void)
{
	tx_600_str(&str_sxxe[1][3][0]);	// set ė M
}

//*****************************************
// XCb`ꂽ̐ԊOM
//   @FXCb`
//*****************************************
void	proc_switch_on(unsigned short us)
{
	if((us & SW2_ON_NOW) != 0){				// ꂽ(select switch)
		tx_600_str_select_on_now();
		return;
	}else if((us & SW2_ON_CONTINUE) != 0){	// ꑱ(select switch)
		tx_600_str_select_continue();
		return;
	}else if((us & SW2_OFF_SHORT) != 0){	// Zꎞ(select switch)
		tx_600_str_select_short();
		return;
	}else if((us & SW2_OFF_LONG) != 0){		// ꎞ(select switch)
		tx_600_str_select_long();
		return;
	}else if((us & SW1_ON_NOW) != 0){		// ꂽ(set switch)
		tx_600_str_set_on_now();
		return;
	}else if((us & SW1_ON_CONTINUE) != 0){	// ꑱ(set switch)
		tx_600_str_set_continue();
		return;
	}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
		tx_600_str_set_short();
		return;
	}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
		tx_600_str_set_long();
		return;
	}
}

//*****************************************
// jLV[[h̃C
//*****************************************
void ir_nixer_mode_main(void)
{
	unsigned char	uc;
	unsigned short	us;

	led_red_on_off(1);
	led_grn_on_off(1);
	led_blu_on_off(1);

	disp_clear_oled_G();							// Clear All Display
	disp_clear_lcd_G();
	disp_ir_nixie_mode_title();						// ^CǧŒ\
	delay_ms(1000);
	for(uc=0;uc < 64;uc++){							// XN[
		set_offse_oled_G(uc);						// OLED scroll
		set_offse_lcd_G(uc);						// GLCD scroll
		delay_ms(100);
	}
	delay_ms(1000);


	led_red_on_off(0);
	led_grn_on_off(0);
	led_blu_on_off(0);

	led_blu_on_off(1);
	timer1_init();
	delay_ms(100);
	led_blu_on_off(0);

	led_grn_on_off(1);
	init_dsm();
	delay_ms(100);
	led_grn_on_off(0);

	cli();
	uart_init_rx_600();							// UART Initial RX 600BPS
	sei();										// 荞݉

	proc_disp_rxd_nixie(uc,1);					// display RXD Init.
	while(1){
		us = get_action_sw();					// XCb`Ԃ
		us &= SW_MASK;							// XCb`ɂ
		if(us != 0){							// ANVL鎞
			led_grn_on_off(1);
			proc_switch_on(us);					// XCb`ꂽ̐ԊOM
			led_grn_on_off(0);
		}

		if(Get_rxd_uart(&uc) != 0){
			led_red_on_off(1);
			proc_disp_rxd_nixie(uc,0);			// display RXD
			led_red_on_off(0);
		}
	}
}

